
var Plugin = function(containerManager) {
	this.pluginList = null;
	this.pluginIndex = new HashMap();
	this.usePluginList = new Array();
	this.pluginParamInfoList = [];
	this.clickPluginChoosedNodeIndex = 0;
	this.clickPluginChoosedNodeName = "";
	this.loadPluginNameList();
	this.loadPluginUIList();
	this.setPluginParamInfoList();
	this.containerManager = containerManager;
};

Plugin.prototype.loadPluginNameList = function() {
	var plugin = this;
	$.ajax({
		type : 'POST',
		url : 'loadPluginName',
		data : {},
		dataType : 'json',
		async : false,
		success : function(response) {
			if (!response.success) {
				information(response.failedMessage);
				return;
			}
			var pluginNameList = response.pluginNames;
			for ( var i = 0; i < pluginNameList.length; i++) {
				plugin.pluginIndex.put(pluginNameList[i], -1);
			}

			pluginListContainerInit($("#pluginList"), pluginNameList);
		}
	});
	function pluginListContainerInit(container, pluginNameList) {
		var pluginListHtmlContent = "";
		for ( var i = 0; i < pluginNameList.length; i++) {
			pluginListHtmlContent += createLineWithRadio(pluginNameList[i],
					"plugin");
		}
		container.html(pluginListHtmlContent);
	}

};

Plugin.prototype.loadPluginUIList = function() {
	var plugin = this;
	$.ajax({
		type : 'POST',
		url : 'loadPluginUIList',
		data : {},
		dataType : 'json',
		async : false,
		success : function(response) {
			if (!response.success) {
				information(response.failedMessage);
				return;
			}
			plugin.pluginList = response.pluginUIs;// List<PluginUIModel>pluginUIModels
		}
	});
};

Plugin.prototype.addUsePlugin = function(item) {
	this.pluginIndex.put(item, this.pluginIndex.get(item) + 1);
	var pluginName = createUsePluginName(item, this.pluginIndex.get(item));
	this.usePluginList.push(pluginName);
	$("#usePlugin").append(
			createLine(pluginName, usePluginList.length, "pluginChoosedList"));
	function createUsePluginName(pluginName, index) {
		return pluginName + '_' + index;
	}
	function createLine(name, index, list) {
		var div = document.createElement("div");
		var p = document.createElement("p");
		var i = document.createElement("i");
		var textNode = document.createTextNode(name);
		div.setAttribute("id", name);
		i.setAttribute("class", "icon-hand-right");
		p.setAttribute("id", index);
		p.setAttribute("class", "");
		if (list == "pluginMethodList") {
			p.setAttribute("onClick", "showMethodDocument(this)");// loadMethodParams
		} else if (list == "pluginChoosedList") {
			p.setAttribute("onClick", "choosePlugin(this);");// 此处用于显示plugin文档
		} else if (list == "editPluginChoosedList") {
			p.setAttribute("onClick", "chooseEditPlugin(this);");
		}
		p.setAttribute("style", "cursor:pointer;width:85%");
		p.appendChild(i);
		p.appendChild(textNode);
		div.appendChild(p);
		return $(div);

	}
};


Plugin.prototype.setClickPluginChoosedNodeIndex = function(selectedNode) {
	this.clickPluginChoosedNodeIndex = $(selectedNode).attr("id");
};

Plugin.prototype.setClickPluginChoosedNodeName = function(selectedNode) {
	this.clickPluginChoosedNodeName = selectedNode.lastChild.nodeValue;
};

Plugin.prototype.setPluginParamInfoList = function() {
	for ( var i = 0; i < this.pluginList.length; i++) {
		var pluginInfoModel = this.pluginList[i].pluginInfoModel;
		this.pluginParamInfoList.push(pluginInfoModel.name);
		this.pluginParamInfoList[pluginInfoModel.name] = pluginInfoModel.paramInfoModels;
	}
};

Plugin.prototype.usePluginParamInfosContainerInit = function(item) {
	var data = this.pluginParamInfoList[item];
	document.getElementById("pluginParams").innerHTML += this.containerManager
			.createParamInforsContainer(data,
					this.usePluginList[this.usePluginList.length - 1],
					this.usePluginList.length - 1);
};

Plugin.prototype.removeUsePluginByClicked = function(container) {
	for ( var i = parseInt(this.clickPluginChoosedNodeIndex + 1); i < this.usePluginList.length; i++) {
		this.usePluginList[i - 1] = this.usePluginList[i];
	}
	this.usePluginList.splice(length - 1, 1);
};

Plugin.prototype.removeUsePluginParamInfos = function() {
	var removeDocumentNode = document.getElementById("pluginParams").childNodes;
	for ( var i = 0; i < removeDocumentNode.length; i++) {
		if ($(removeDocumentNode[i]).attr("id") == this.clickPluginChoosedNodeIndex) {
			document.getElementById("pluginParams").removeChild(
					removeDocumentNode[i]);
			break;
		}
	}
};

Plugin.prototype.clearUsePluginContainer = function() {
	this.usePluginList.splice(0, this.usePluginList.length);
	for ( var i = 0; i < this.pluginNameList.length; i++) {
		this.pluginIndex.put(this.pluginNameList[i], 0);
	}
};
