<!DOCTYPE html>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<html>
<head>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<meta charset="utf-8">
<title>Bench4Q</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description"
	content="Bench4Q, a new method for QOS benchmarking.">
<link id="bs-css" href="lib/chrisma/css/bootstrap-cerulean.css"
	rel="stylesheet">
<link href="lib/chrisma/css/opa-icons.css" rel="stylesheet">
<link
	href="http://ajax.aspnetcdn.com/ajax/bootstrap/2.3.2/css/bootstrap-responsive.css"
	rel="stylesheet">
<link href="lib/chrisma/css/charisma-app.css" rel="stylesheet">
<style type="text/css">
body {
	padding-bottom: 40px;
}

.sidebar-nav {
	padding: 9px 0;
}
</style>
<link href="lib/chrisma/css/charisma-app.css" rel="stylesheet">
<link href='css/bench4q.css' rel='stylesheet'>
<link href='lib/buttons/buttons.css' rel='stylesheet'>
<link href='css/test.css' rel='stylesheet'>
<link rel="shortcut icon" href="images/bench4q.png">
</head>

<body>
	<fmt:bundle basename="i18n">
		<jsp:include page="publiccontrol/navigatebar.jsp"></jsp:include>
		<div class="container-fluid">
			<div class="row-fluid">
				<jsp:include page="publiccontrol/leftmenubar.jsp"></jsp:include>
				<div id="content" class="span10">
					<!-- content starts -->

					<!-- up navigatebar start-->
					<div>
						<ul class="breadcrumb">
							<li><a href="homepage.jsp"><fmt:message key="home" /></a> <span
								class="divider">/</span></li>
							<li><a href="#"><fmt:message key="creatatest" /></a></li>
						</ul>
					</div>
					<div>
						<h3>
							<fmt:message key="creatatest" />
						</h3>
					</div>
					<div class="test-name-frame">
						<div>
							<p class="test-name-title">
								<fmt:message key="testName" />
							</p>
							<input id="testConfigurationName" class="name-input" type="text"
								class="text-left" onblur="checkName()" />
							<div id="nameMessage" class="hide">
								<fmt:message key="empty" />
							</div>
						</div>
					</div>
					<!--box content-->

					<div class="title-frame">
						<a href="#"><i class="icon-minus" id="icon-load"
							onClick="toggleTestExecutionPlan()"></i></a>
						<p class="title">
							<fmt:message key="testPlanConfig" />
						</p>
					</div>
					<div id="loadTestExecutionPlan" class="content-frame row-fluid">
						<div class="span4">
							<table id="loadConfig" class="table-margin-top">

								<tr>
									<td><fmt:message key="test-load" /></td>
									<td><input id="RequireLoad" class="load-config-input"
										type="text" value="10"
										onblur="loadSchedulePlot();checkLoadConfig()" /></td>
								</tr>
								<tr>
									<td height="15"></td>
								</tr>
								<tr>
									<td><fmt:message key="test-warmUp" />(s)</td>
									<td><input id="WarmUp" class="load-config-input"
										type="text" value="10"
										onblur="loadSchedulePlot();checkLoadConfig()" /></td>
								</tr>
								<tr>
									<td height="15"></td>
								</tr>
								<tr>
									<td><fmt:message key="test-coldDown" />(s)</td>
									<td><input id="CoolDown" class="load-config-input"
										type="text" value="10"
										onblur="loadSchedulePlot();checkLoadConfig()" /></td>
								</tr>
								<tr>
									<td height="15"></td>
								</tr>
								<tr>
									<td><fmt:message key="test-excuteRange" />(s)</td>
									<td><input id="ExecuteRange" class="load-config-input"
										type="text" value="10"
										onblur="loadSchedulePlot();checkLoadConfig()" /></td>
								</tr>
							</table>
							<span id="loadConfigMessage" class="hide">all input can
								not be empty <br />and must be greater than zero!
							</span>
						</div>
						<div class="span8">
							<div id="highchartsPlot"></div>
						</div>
					</div>

					<div class="title-frame">
						<a href="#"><i class="icon-minus" id="icon-user"
							onClick="toggleUserScenarios()"></i></a>
						<p class="title">
							<fmt:message key="script" />
						</p>
					</div>
					<div id="userScenarios" class="content-frame">

						<table id="userConfig" class="table-margin-top .table-config">
							<thead>
								<tr>
									<th><fmt:message key="allocation" /> %</th>
									<th><fmt:message key="scriptname" /></th>
									<th><fmt:message key="filterStatic" /></th>
									<th><fmt:message key="filterTime" /></th>
									<th><fmt:message key="actions" /></th>

								</tr>
							</thead>
							<tbody>
								<tr>

									<td><input class="allocation-input " value="100"
										type="text" onblur="changeTotal();checkUserScenarios()" /> %</td>
									<td><select name="select">

									</select></td>

									<td><input type="checkbox" name="staticResources"
										value="false" data-toggle="tooltip" data-placement="left"
										title=<fmt:message key="staticTip" />> <fmt:message
											key="filterStatic" /></td>
									<td><input type="checkbox" name="timer" value="false"
										data-toggle="tooltip" data-placement="left"
										title=<fmt:message key="timeTip" />> <fmt:message
											key="filterTime" /><br></td>
									<td><a href="#" class="button" onClick="viewScript(this)"><img
											src="images/script_edit.png" alt="Add"> <fmt:message
												key="test-editScript" /></a></td>
								</tr>
							</tbody>
						</table>
						<table>
							<tr>
								<th><fmt:message key="total" />:</th>
								<th id="totalNumber" class="total-right">100%</th>
							</tr>
						</table>
						<div id="alertMessage" class="hide">The total allocation
							needs to be 100%</div>
						<button type="submit" class="btn btn-primary"
							id="userScenariosButton"
							onClick="addScenario();checkUserScenarios()">
							<fmt:message key="addScript" />
						</button>

						<button type="submit" class="btn btn-primary" id="createNewScript"
							onClick="createNewScript()">
							<fmt:message key="test_jsp_makeNewScript" />
						</button>

						<div id="userConfigMessage" class="hide">all input can not
							be empty and must be greater than zero!</div>
					</div>

					<div class="title-frame">
						<a href="#"><i class="icon-plus float-left" id="icon-ip"
							onClick="toggleIpConfig()"></i></a>
						<p class="title">
							<fmt:message key="sutIp" />
						</p>
					</div>
					<div id="ipConfig" class="content-frame hide">
						<table id="ipConfigTable" class="table-margin-top">
							<!-- 	<tr>
								<th>IP:</th>
								<th><input type="text" class="ip-input" onblur="checkIP()" /></th>
							</tr> -->
						</table>
						<button type="submit" class="btn btn-primary add-button"
							onClick="addIP();checkIP()">
							<fmt:message key="addIp" />
						</button>
						<div id="ipConfigMessage" class="hide">
							<fmt:message key="test-iptip" />
						</div>
					</div>
					<div class="span12 center">
						<button class="btn btn-large btn-primary" onClick="startTest()">
							<fmt:message key="startTest" />
						</button>
					</div>

				</div>
			</div>
			<hr>
			<jsp:include page="publiccontrol/footer.jsp"></jsp:include>
		</div>
		<script
			src="http://ajax.aspnetcdn.com/ajax/jQuery/jquery-2.1.0.min.js"></script>
		<script
			src="http://ajax.aspnetcdn.com/ajax/jquery.ui/1.10.4/jquery-ui.min.js"></script>
		<script
			src="http://ajax.aspnetcdn.com/ajax/bootstrap/2.3.1/bootstrap.min.js"></script>
		<script src="lib/bootstrap/js/bootstrap-tooltip.js"></script>
		<script src="lib/jqueryi18n/jquery.i18n.properties-1.0.9.js"></script>
		<script src="lib/chrisma/js/jquery.cookie.js"></script>
		<script src="lib/chrisma/js/theme.js"></script>
		<script src="script/Share/loadProperties.js"></script>
		<script src="http://code.highcharts.com/highcharts.js"></script>
		<script src="script/test.js"></script>
		<script src="lib/other/jquery.noty.packaged.min.js"></script>
		<script src="script/scriptManager/uiFactory.js"></script>
	</fmt:bundle>
</body>
</html>
